diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/unix-system-condition.cc ns-3.31/src/core/model/unix-system-condition.cc
--- ns-3.30.1/src/core/model/unix-system-condition.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/unix-system-condition.cc	2020-06-27 17:38:30.000000000 -0700
@@ -40,7 +40,8 @@
  * \ingroup thread
  * Implementation of SystemCondition for Unix-like systems.
  */
-class SystemConditionPrivate {
+class SystemConditionPrivate
+{
 public:
   /** Conversion from ns to s. */
   static const uint64_t NS_PER_SEC = (uint64_t)1000000000;
@@ -98,7 +99,7 @@
   pthread_mutexattr_t mAttr;
   pthread_mutexattr_init (&mAttr);
 //
-// Linux and OS X (at least) have, of course chosen different names for the 
+// Linux and OS X (at least) have, of course chosen different names for the
 // error checking flags just to make life difficult.
 //
 #if defined (PTHREAD_MUTEX_ERRORCHECK_NP)
@@ -114,27 +115,27 @@
   pthread_cond_init (&m_cond, &cAttr);
 }
 
-SystemConditionPrivate::~SystemConditionPrivate() 
+SystemConditionPrivate::~SystemConditionPrivate ()
 {
   NS_LOG_FUNCTION (this);
   pthread_mutex_destroy (&m_mutex);
   pthread_cond_destroy (&m_cond);
 }
-	
+
 void
 SystemConditionPrivate::SetCondition (bool condition)
 {
   NS_LOG_FUNCTION (this << condition);
   m_condition = condition;
 }
-	
+
 bool
 SystemConditionPrivate::GetCondition (void)
 {
   NS_LOG_FUNCTION (this);
   return m_condition;
 }
-	
+
 void
 SystemConditionPrivate::Signal (void)
 {
@@ -144,7 +145,7 @@
   pthread_cond_signal (&m_cond);
   pthread_mutex_unlock (&m_mutex);
 }
-	
+
 void
 SystemConditionPrivate::Broadcast (void)
 {
@@ -197,63 +198,63 @@
       rc = pthread_cond_timedwait (&m_cond, &m_mutex, &ts);
       if (rc == ETIMEDOUT)
         {
-          pthread_mutex_unlock (&m_mutex); 
+          pthread_mutex_unlock (&m_mutex);
           return true;
         }
     }
   pthread_mutex_unlock (&m_mutex);
   return false;
 }
-	
-SystemCondition::SystemCondition() 
+
+SystemCondition::SystemCondition ()
   : m_priv (new SystemConditionPrivate ())
 {
   NS_LOG_FUNCTION (this);
 }
 
-SystemCondition::~SystemCondition () 
+SystemCondition::~SystemCondition ()
 {
   NS_LOG_FUNCTION (this);
   delete m_priv;
 }
 
 void
-SystemCondition::SetCondition (bool condition) 
+SystemCondition::SetCondition (bool condition)
 {
   NS_LOG_FUNCTION (this << condition);
   m_priv->SetCondition (condition);
 }
 
 bool
-SystemCondition::GetCondition (void) 
+SystemCondition::GetCondition (void)
 {
   NS_LOG_FUNCTION (this);
   return m_priv->GetCondition ();
 }
 
 void
-SystemCondition::Signal (void) 
+SystemCondition::Signal (void)
 {
   NS_LOG_FUNCTION (this);
   m_priv->Signal ();
 }
 
 void
-SystemCondition::Broadcast (void) 
+SystemCondition::Broadcast (void)
 {
   NS_LOG_FUNCTION (this);
   m_priv->Broadcast ();
 }
 
 void
-SystemCondition::Wait (void) 
+SystemCondition::Wait (void)
 {
   NS_LOG_FUNCTION (this);
   m_priv->Wait ();
 }
 
 bool
-SystemCondition::TimedWait (uint64_t ns) 
+SystemCondition::TimedWait (uint64_t ns)
 {
   NS_LOG_FUNCTION (this << ns);
   return m_priv->TimedWait (ns);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/unix-system-mutex.cc ns-3.31/src/core/model/unix-system-mutex.cc
--- ns-3.30.1/src/core/model/unix-system-mutex.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/unix-system-mutex.cc	2020-06-27 17:38:30.000000000 -0700
@@ -38,13 +38,15 @@
 NS_LOG_COMPONENT_DEFINE_MASK ("SystemMutex", ns3::LOG_PREFIX_TIME);
 
 /** System-dependent implementation of SystemMutex. */
-class SystemMutexPrivate {
-public: 
-  SystemMutexPrivate ();    
+class SystemMutexPrivate
+{
+public:
+  SystemMutexPrivate ();
   ~SystemMutexPrivate ();
-	
+
   void Lock (void);         /**< Acquire ownership of the mutex. */
   void Unlock (void);       /**< Release ownership of the mutex. */
+
 private:
   pthread_mutex_t m_mutex;  /**< The mutex. */
 };
@@ -57,11 +59,11 @@
   pthread_mutexattr_init (&attr);
 //
 // Make this an error checking mutex.  This will check to see if the current
-// thread already owns the mutex before trying to lock it.  Instead of 
+// thread already owns the mutex before trying to lock it.  Instead of
 // deadlocking it returns an error.  It will also check to make sure a thread
 // has previously called pthread_mutex_lock when it calls pthread_mutex_unlock.
 //
-// Linux and OS X (at least) have, of course chosen different names for the 
+// Linux and OS X (at least) have, of course chosen different names for the
 // error checking flags just to make life difficult.
 //
 #if defined (PTHREAD_MUTEX_ERRORCHECK_NP)
@@ -72,28 +74,28 @@
   pthread_mutex_init (&m_mutex, &attr);
 }
 
-SystemMutexPrivate::~SystemMutexPrivate() 
+SystemMutexPrivate::~SystemMutexPrivate ()
 {
   NS_LOG_FUNCTION (this);
   pthread_mutex_destroy (&m_mutex);
 }
-	
+
 void
 SystemMutexPrivate::Lock (void)
 {
   NS_LOG_FUNCTION (this);
 
   int rc = pthread_mutex_lock (&m_mutex);
-  if (rc != 0) 
+  if (rc != 0)
     {
       NS_FATAL_ERROR ("SystemMutexPrivate::Lock()"
                       "pthread_mutex_lock failed: " << rc << " = \"" <<
                       std::strerror (rc) << "\"");
     }
 }
-	
+
 void
-SystemMutexPrivate::Unlock (void) 
+SystemMutexPrivate::Unlock (void)
 {
   NS_LOG_FUNCTION (this);
 
@@ -106,13 +108,13 @@
     }
 }
 
-SystemMutex::SystemMutex() 
+SystemMutex::SystemMutex ()
   : m_priv (new SystemMutexPrivate ())
 {
   NS_LOG_FUNCTION (this);
 }
 
-SystemMutex::~SystemMutex() 
+SystemMutex::~SystemMutex ()
 {
   NS_LOG_FUNCTION (this);
   delete m_priv;
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/unix-system-wall-clock-ms.cc ns-3.31/src/core/model/unix-system-wall-clock-ms.cc
--- ns-3.30.1/src/core/model/unix-system-wall-clock-ms.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/unix-system-wall-clock-ms.cc	2020-06-27 17:38:30.000000000 -0700
@@ -38,7 +38,8 @@
  * \ingroup system
  * \brief System-dependent implementation for SystemWallClockMs
  */
-class SystemWallClockMsPrivate {
+class SystemWallClockMsPrivate
+{
 public:
   /** \copydoc SystemWallClockMs::Start() */
   void Start (void);
@@ -59,7 +60,7 @@
   int64_t m_elapsedSystem;  //!< Elapsed system time, in ms.
 };
 
-void 
+void
 SystemWallClockMsPrivate::Start (void)
 {
   NS_LOG_FUNCTION (this);
@@ -81,18 +82,18 @@
   // is bad since this number is fractional on most machines and would result
   // in divide by zero errors due to integer rounding.
   //
-  // Multiplying by milliseconds per clock tick works up to a clock resolution 
+  // Multiplying by milliseconds per clock tick works up to a clock resolution
   // of 1000 ticks per second.  If we go  past this point, we begin to get zero
-  // elapsed times when millisecondsPerTick becomes fractional and another 
+  // elapsed times when millisecondsPerTick becomes fractional and another
   // rounding error appears.
   //
-  // So rounding errors using integers can bite you from both direction.  Since 
-  // all of our targets have math coprocessors, why not just use doubles 
+  // So rounding errors using integers can bite you from both direction.  Since
+  // all of our targets have math coprocessors, why not just use doubles
   // internally?  Works fine, lasts a long time.
   //
-  // If millisecondsPerTick becomes fractional, and an elapsed time greater than 
-  // a milliscond is measured, the function will work as expected.  If an elapsed 
-  // time is measured that turns out to be less than a millisecond, we'll just 
+  // If millisecondsPerTick becomes fractional, and an elapsed time greater than
+  // a milliscond is measured, the function will work as expected.  If an elapsed
+  // time is measured that turns out to be less than a millisecond, we'll just
   // return zero which would, I think, also will be expected.
   //
   NS_LOG_FUNCTION (this);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/valgrind.h ns-3.31/src/core/model/valgrind.h
--- ns-3.30.1/src/core/model/valgrind.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/valgrind.h	2020-06-27 17:38:30.000000000 -0700
@@ -1,4 +1,4 @@
-/* -*- c -*-
+/* -*- c -*-  *NS_CHECK_STYLE_OFF* 
    ----------------------------------------------------------------
 
    Notice that the following BSD-style license applies to this one
@@ -5622,3 +5622,5 @@
 #undef PLAT_mips64_linux
 
 #endif   /* __VALGRIND_H */
+
+/* *NS_CHECK_STYLE_ON* */
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/vector.cc ns-3.31/src/core/model/vector.cc
--- ns-3.30.1/src/core/model/vector.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/vector.cc	2020-06-27 17:38:30.000000000 -0700
@@ -110,8 +110,8 @@
 {
   char c1, c2;
   is >> vector.x >> c1 >> vector.y >> c2 >> vector.z;
-  if (c1 != ':' ||
-      c2 != ':')
+  if (c1 != ':'
+      || c2 != ':')
     {
       is.setstate (std::ios_base::failbit);
     }
@@ -122,6 +122,30 @@
   return std::tie (a.x, a.y, a.z) <
          std::tie (b.x, b.y, b.z);
 }
+bool operator <= (const Vector3D &a, const Vector3D &b)
+{
+  return std::tie (a.x, a.y, a.z) <=
+         std::tie (b.x, b.y, b.z);
+}
+bool operator > (const Vector3D &a, const Vector3D &b)
+{
+  return std::tie (a.x, a.y, a.z) >
+         std::tie (b.x, b.y, b.z);
+}
+bool operator >= (const Vector3D &a, const Vector3D &b)
+{
+  return std::tie (a.x, a.y, a.z) >=
+         std::tie (b.x, b.y, b.z);
+}
+bool operator == (const Vector3D &a, const Vector3D &b)
+{
+  return std::tie (a.x, a.y, a.z) ==
+         std::tie (b.x, b.y, b.z);
+}
+bool operator != (const Vector3D &a, const Vector3D &b)
+{
+  return !(a == b);
+}
 Vector3D
 operator + (const Vector3D &a, const Vector3D &b)
 {
@@ -152,6 +176,30 @@
   return std::tie (a.x, a.y) <
          std::tie (b.x, b.y);
 }
+bool operator <= (const Vector2D &a, const Vector2D &b)
+{
+  return std::tie (a.x, a.y) <=
+         std::tie (b.x, b.y);
+}
+bool operator > (const Vector2D &a, const Vector2D &b)
+{
+  return std::tie (a.x, a.y) >
+         std::tie (b.x, b.y);
+}
+bool operator >= (const Vector2D &a, const Vector2D &b)
+{
+  return std::tie (a.x, a.y) >=
+         std::tie (b.x, b.y);
+}
+bool operator == (const Vector2D &a, const Vector2D &b)
+{
+  return std::tie (a.x, a.y) ==
+         std::tie (b.x, b.y);
+}
+bool operator != (const Vector2D &a, const Vector2D &b)
+{
+  return !(a == b);
+}
 Vector2D
 operator + (const Vector2D &a, const Vector2D &b)
 {
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/vector.h ns-3.31/src/core/model/vector.h
--- ns-3.30.1/src/core/model/vector.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/vector.h	2020-06-27 17:38:30.000000000 -0700
@@ -36,7 +36,7 @@
  * \defgroup geometry Geometry primitives
  * \brief Primitives for geometry, such as vectors and angles.
  */
-  
+
 /**
  * \ingroup geometry
  * \brief a 3d vector
@@ -55,7 +55,7 @@
   Vector3D (double _x, double _y, double _z);
   /** Create vector (0.0, 0.0, 0.0) */
   Vector3D ();
-  
+
   double x;  //!< x coordinate of vector
   double y;  //!< y coordinate of vector
   double z;  //!< z coordinate of vector
@@ -65,15 +65,15 @@
    * \returns the vector length.
    */
   double GetLength () const;
-  
+
   /**
    * \brief Calculate the Cartesian distance between two points.
    * \param [in] a One point
    * \param [in] b Another point
-   * \returns The distance between \p a and \p b.
+   * \returns The distance between \pname{a} and \pname{b}.
    */
   friend double CalculateDistance (const Vector3D &a, const Vector3D &b);
-  
+
   /**
    * Output streamer.
    * Vectors are written as "x:y:z".
@@ -99,15 +99,55 @@
    * Less than comparison operator
    * \param [in] a lhs vector
    * \param [in] b rhs vector
-   * \returns \c true if \p a is less than \p b
+   * \returns \c true if \pname{a} is less than \pname{b}
    */
   friend bool operator < (const Vector3D &a, const Vector3D &b);
 
   /**
+   * Less than or equal to comparison operator
+   * \param [in] a lhs vector
+   * \param [in] b rhs vector
+   * \returns \c true if \pname{a} is less than or equal to \pname{b}.
+   */
+  friend bool operator <= (const Vector3D &a, const Vector3D &b);
+
+  /**
+   * Greater than comparison operator
+   * \param [in] a lhs vector
+   * \param [in] b rhs vector
+   * \returns \c true if \pname{a} is greater than \pname{b}.
+   */
+  friend bool operator > (const Vector3D &a, const Vector3D &b);
+
+  /**
+   * Greater than or equal to comparison operator
+   * \param [in] a lhs vector
+   * \param [in] b rhs vector
+   * \returns \c true if \pname{a} is greater than or equal to \pname{b}.
+   */
+  friend bool operator >= (const Vector3D &a, const Vector3D &b);
+
+  /**
+   * Equality operator.
+   * \param [in] a lhs vector.
+   * \param [in] b rhs vector.
+   * \returns \c true if \pname{a} is equal to \pname{b}.
+   */
+  friend bool operator == (const Vector3D &a, const Vector3D &b);
+
+  /**
+   * Inequality operator.
+   * \param [in] a lhs vector.
+   * \param [in] b rhs vector.
+   * \returns \c true if \pname{a} is not equal to \pname{b}.
+   */
+  friend bool operator != (const Vector3D &a, const Vector3D &b);
+
+  /**
    * Addition operator.
    * \param [in] a lhs vector.
    * \param [in] b rhs vector.
-   * \returns The vector sum of \p a and \p b.
+   * \returns The vector sum of \pname{a} and \pname{b}.
    */
   friend Vector3D operator + (const Vector3D &a, const Vector3D &b);
 
@@ -115,7 +155,7 @@
    * Subtraction operator.
    * \param [in] a lhs vector.
    * \param [in] b rhs vector.
-   * \returns The vector difference of \p a and \p b.
+   * \returns The vector difference of \pname{a} and \pname{b}.
    */
   friend Vector3D operator - (const Vector3D &a, const Vector3D &b);
 };
@@ -143,15 +183,15 @@
   // works:  /** \copydoc ns3::Vector3D::GetLength() */
   /** \copydoc Vector3D::GetLength() */
   double GetLength () const;
-  
+
   /**
    * \brief Calculate the Cartesian distance between two points.
    * \param [in] a One point
    * \param [in] b Another point
-   * \returns The distance between \p a and \p b.
+   * \returns The distance between \pname{a} and \pname{b}.
    */
   friend double CalculateDistance (const Vector2D &a, const Vector2D &b);
-  
+
   /**
    * Output streamer.
    * Vectors are written as "x:y".
@@ -177,15 +217,55 @@
    * Less than comparison operator
    * \param [in] a lhs vector
    * \param [in] b rhs vector
-   * \returns \c true if \p a is less than \p b
+   * \returns \c true if \pname{a} is less than \pname{b}
    */
   friend bool operator < (const Vector2D &a, const Vector2D &b);
 
   /**
+   * Less than or equal to comparison operator
+   * \param [in] a lhs vector
+   * \param [in] b rhs vector
+   * \returns \c true if \pname{a} is less than or equal to \pname{b}.
+   */
+  friend bool operator <= (const Vector2D &a, const Vector2D &b);
+
+  /**
+   * Greater than comparison operator
+   * \param [in] a lhs vector
+   * \param [in] b rhs vector
+   * \returns \c true if \pname{a} is greater than \pname{b}.
+   */
+  friend bool operator > (const Vector2D &a, const Vector2D &b);
+
+  /**
+   * Greater than or equal to comparison operator
+   * \param [in] a lhs vector
+   * \param [in] b rhs vector
+   * \returns \c true if \pname{a} is greater than or equal to \pname{b}.
+   */
+  friend bool operator >= (const Vector2D &a, const Vector2D &b);
+
+  /**
+   * Equality operator.
+   * \param [in] a lhs vector.
+   * \param [in] b rhs vector.
+   * \returns \c true if \pname{a} is equal to \pname{b}.
+   */
+  friend bool operator == (const Vector2D &a, const Vector2D &b);
+
+  /**
+   * Inequality operator.
+   * \param [in] a lhs vector.
+   * \param [in] b rhs vector.
+   * \returns \c true if \pname{a} is not equal to \pname{b}.
+   */
+  friend bool operator != (const Vector2D &a, const Vector2D &b);
+
+  /**
    * Addition operator.
    * \param [in] a lhs vector.
    * \param [in] b rhs vector.
-   * \returns The vector sum of \p a and \p b.
+   * \returns The vector sum of \pname{a} and \pname{b}.
    */
   friend Vector2D operator + (const Vector2D &a, const Vector2D &b);
 
@@ -193,7 +273,7 @@
    * Subtraction operator.
    * \param [in] a lhs vector.
    * \param [in] b rhs vector.
-   * \returns The vector difference of \p a and \p b.
+   * \returns The vector difference of \pname{a} and \pname{b}.
    */
   friend Vector2D operator - (const Vector2D &a, const Vector2D &b);
 };
@@ -204,9 +284,9 @@
 std::ostream &operator << (std::ostream &os, const Vector2D &vector);
 std::istream &operator >> (std::istream &is, Vector3D &vector);
 std::istream &operator >> (std::istream &is, Vector2D &vector);
-bool operator < (const Vector3D &a, const Vector3D &b); 
+bool operator < (const Vector3D &a, const Vector3D &b);
 bool operator < (const Vector2D &a, const Vector2D &b);
-  
+
 ATTRIBUTE_HELPER_HEADER (Vector3D);
 ATTRIBUTE_HELPER_HEADER (Vector2D);
 
@@ -221,7 +301,7 @@
  * Vector alias typedef for compatibility with mobility models
  */
 typedef Vector3DValue VectorValue;
-  
+
 /**
  * \relates Vector3D
  * Vector alias typedef for compatibility with mobility models
@@ -236,7 +316,7 @@
  * \copydoc ns3::MakeAccessorHelper(T1)
  * \see AttributeAccessor
  */
-  
+
 /**
  * \relates Vector3D
  * \fn ns3::Ptr<const ns3::AttributeAccessor> ns3::MakeVectorAccessor (T1 a1, T2 a2)
@@ -252,8 +332,8 @@
  * \see AttributeChecker
  */
 Ptr<const AttributeChecker> MakeVectorChecker (void);
-  
-  
+
+
 } // namespace ns3
 
 #endif /* NS3_VECTOR_H */
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/watchdog.cc ns-3.31/src/core/model/watchdog.cc
--- ns-3.30.1/src/core/model/watchdog.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/watchdog.cc	2020-06-27 17:38:30.000000000 -0700
@@ -42,6 +42,7 @@
 Watchdog::~Watchdog ()
 {
   NS_LOG_FUNCTION (this);
+  m_event.Cancel ();
   delete m_impl;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/watchdog.h ns-3.31/src/core/model/watchdog.h
--- ns-3.30.1/src/core/model/watchdog.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/watchdog.h	2020-06-27 17:38:30.000000000 -0700
@@ -53,7 +53,7 @@
  *
  * \see Timer for a more sophisticated general purpose timer.
  */
-class Watchdog 
+class Watchdog
 {
 public:
   /** Constructor. */
@@ -75,6 +75,7 @@
   /**
    * Set the function to execute when the timer expires.
    *
+   * \tparam FN \deduced The type of the function.
    * \param [in] fn The function
    *
    * Store this function in this Timer for later use by Timer::Schedule.
@@ -101,71 +102,11 @@
    */
   /**@{*/
   /**
-   * \tparam T1 \deduced Type of the first argument.
-   * \param [in] a1 The first argument
+   * \tparam Ts \deduced Argument types.
+   * \param [in] args arguments
    */
-  template <typename T1>
-  void SetArguments (T1 a1);
-  /**
-   * \tparam T1 \deduced Type of the first argument.
-   * \tparam T2 \deduced Type of the second argument.
-   * \param [in] a1 the first argument
-   * \param [in] a2 the second argument
-   */
-  template <typename T1, typename T2>
-  void SetArguments (T1 a1, T2 a2);
-  /**
-   * \tparam T1 \deduced Type of the first argument.
-   * \tparam T2 \deduced Type of the second argument.
-   * \tparam T3 \deduced Type of the third argument.
-   * \param [in] a1 the first argument
-   * \param [in] a2 the second argument
-   * \param [in] a3 the third argument
-   */
-  template <typename T1, typename T2, typename T3>
-  void SetArguments (T1 a1, T2 a2, T3 a3);
-  /**
-   * \tparam T1 \deduced Type of the first argument.
-   * \tparam T2 \deduced Type of the second argument.
-   * \tparam T3 \deduced Type of the third argument.
-   * \tparam T4 \deduced Type of the fourth argument.
-   * \param [in] a1 the first argument
-   * \param [in] a2 the second argument
-   * \param [in] a3 the third argument
-   * \param [in] a4 the fourth argument
-   */
-  template <typename T1, typename T2, typename T3, typename T4>
-  void SetArguments (T1 a1, T2 a2, T3 a3, T4 a4);
-  /**
-   * \tparam T1 \deduced Type of the first argument.
-   * \tparam T2 \deduced Type of the second argument.
-   * \tparam T3 \deduced Type of the third argument.
-   * \tparam T4 \deduced Type of the fourth argument.
-   * \tparam T5 \deduced Type of the fifth argument.
-   * \param [in] a1 the first argument
-   * \param [in] a2 the second argument
-   * \param [in] a3 the third argument
-   * \param [in] a4 the fourth argument
-   * \param [in] a5 the fifth argument
-   */
-  template <typename T1, typename T2, typename T3, typename T4, typename T5>
-  void SetArguments (T1 a1, T2 a2, T3 a3, T4 a4, T5 a5);
-  /**
-   * \tparam T1 \deduced Type of the first argument.
-   * \tparam T2 \deduced Type of the second argument.
-   * \tparam T3 \deduced Type of the third argument.
-   * \tparam T4 \deduced Type of the fourth argument.
-   * \tparam T5 \deduced Type of the fifth argument.
-   * \tparam T6 \deduced Type of the sixth argument.
-   * \param [in] a1 the first argument
-   * \param [in] a2 the second argument
-   * \param [in] a3 the third argument
-   * \param [in] a4 the fourth argument
-   * \param [in] a5 the fifth argument
-   * \param [in] a6 the sixth argument
-   */
-  template <typename T1, typename T2, typename T3, typename T4, typename T5, typename T6>
-  void SetArguments (T1 a1, T2 a2, T3 a3, T4 a4, T5 a5, T6 a6);
+  template <typename... Ts>
+  void SetArguments (Ts&&... args);
   /**@}*/
 
 private:
@@ -195,89 +136,30 @@
 
 
 template <typename FN>
-void 
+void
 Watchdog::SetFunction (FN fn)
 {
   delete m_impl;
   m_impl = MakeTimerImpl (fn);
 }
 template <typename MEM_PTR, typename OBJ_PTR>
-void 
+void
 Watchdog::SetFunction (MEM_PTR memPtr, OBJ_PTR objPtr)
 {
   delete m_impl;
   m_impl = MakeTimerImpl (memPtr, objPtr);
 }
 
-template <typename T1>
-void 
-Watchdog::SetArguments (T1 a1)
-{
-  if (m_impl == 0)
-    {
-      NS_FATAL_ERROR ("You cannot set the arguments of a Watchdog before setting its function.");
-      return;
-    }
-  m_impl->SetArgs (a1);
-}
-template <typename T1, typename T2>
-void 
-Watchdog::SetArguments (T1 a1, T2 a2)
-{
-  if (m_impl == 0)
-    {
-      NS_FATAL_ERROR ("You cannot set the arguments of a Watchdog before setting its function.");
-      return;
-    }
-  m_impl->SetArgs (a1, a2);
-}
-
-template <typename T1, typename T2, typename T3>
-void 
-Watchdog::SetArguments (T1 a1, T2 a2, T3 a3)
-{
-  if (m_impl == 0)
-    {
-      NS_FATAL_ERROR ("You cannot set the arguments of a Watchdog before setting its function.");
-      return;
-    }
-  m_impl->SetArgs (a1, a2, a3);
-}
-
-template <typename T1, typename T2, typename T3, typename T4>
-void 
-Watchdog::SetArguments (T1 a1, T2 a2, T3 a3, T4 a4)
-{
-  if (m_impl == 0)
-    {
-      NS_FATAL_ERROR ("You cannot set the arguments of a Watchdog before setting its function.");
-      return;
-    }
-  m_impl->SetArgs (a1, a2, a3, a4);
-}
-
-template <typename T1, typename T2, typename T3, typename T4, typename T5>
-void 
-Watchdog::SetArguments (T1 a1, T2 a2, T3 a3, T4 a4, T5 a5)
-{
-  if (m_impl == 0)
-    {
-      NS_FATAL_ERROR ("You cannot set the arguments of a Watchdog before setting its function.");
-      return;
-    }
-  m_impl->SetArgs (a1, a2, a3, a4, a5);
-}
-
-template <typename T1, typename T2, typename T3, typename T4, typename T5, typename T6>
-void 
-Watchdog::SetArguments (T1 a1, T2 a2, T3 a3, T4 a4, T5 a5, T6 a6)
+template <typename... Ts>
+void
+Watchdog::SetArguments (Ts&&... args)
 {
   if (m_impl == 0)
     {
       NS_FATAL_ERROR ("You cannot set the arguments of a Watchdog before setting its function.");
       return;
     }
-  m_impl->SetArgs (a1, a2, a3, a4, a5, a6);
+  m_impl->SetArgs (std::forward<Ts>(args)...);
 }
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/win32-system-wall-clock-ms.cc ns-3.31/src/core/model/win32-system-wall-clock-ms.cc
--- ns-3.30.1/src/core/model/win32-system-wall-clock-ms.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/win32-system-wall-clock-ms.cc	2020-06-27 17:38:30.000000000 -0700
@@ -36,7 +36,8 @@
  * \ingroup system
  * \brief System-dependent implementation for SystemWallClockMs
  */
-class SystemWallClockMsPrivate {
+class SystemWallClockMsPrivate
+{
 public:
   /** \copydoc SystemWallClockMs::Start() */
   void Start (void);
@@ -51,12 +52,12 @@
 
 private:
   clock_t m_startTime;      //!< The wall clock start time.
-  int64_t m_elapsedReal;    //!< Elapsed real time, in ms.  
-  int64_t m_elapsedUser;    //!< Elapsed user time, in ms.  
+  int64_t m_elapsedReal;    //!< Elapsed real time, in ms.
+  int64_t m_elapsedUser;    //!< Elapsed user time, in ms.
   int64_t m_elapsedSystem;  //!< Elapsed system time, in ms.
 };
 
-void 
+void
 SystemWallClockMsPrivate::Start (void)
 {
   NS_LOG_FUNCTION (this);
@@ -78,18 +79,18 @@
   // per millisecond is bad since this number is fractional on most machines
   // and would result in divide by zero errors due to integer rounding.
   //
-  // Multiplying by milliseconds per clock tick works up to a clock resolution 
+  // Multiplying by milliseconds per clock tick works up to a clock resolution
   // of 1000 ticks per second.  If we go  past this point, we begin to get zero
-  // elapsed times when millisecondsPerTick becomes fractional and another 
+  // elapsed times when millisecondsPerTick becomes fractional and another
   // rounding error appears.
   //
-  // So rounding errors using integers can bite you from two direction.  Since 
-  // all of our targets have math coprocessors, why not just use doubles 
+  // So rounding errors using integers can bite you from two direction.  Since
+  // all of our targets have math coprocessors, why not just use doubles
   // internally?  Works fine, lasts a long time.
   //
-  // If millisecondsPerTick becomes fractional, and an elapsed time greater than 
-  // a millisecond is measured, the function will work as expected.  If an elapsed 
-  // time is measured that turns out to be less than a millisecond, we'll just 
+  // If millisecondsPerTick becomes fractional, and an elapsed time greater than
+  // a millisecond is measured, the function will work as expected.  If an elapsed
+  // time is measured that turns out to be less than a millisecond, we'll just
   // return zero which would, I think, also will be expected.
   //
   NS_LOG_FUNCTION (this);
